package com.icontrols.kakao.service.impl;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.concurrent.CompletableFuture;

import javax.annotation.Resource;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.icontrols.kakao.common.KAKAO_RESULT;
import com.icontrols.kakao.common.KEY_INFO;
import com.icontrols.kakao.common.utils.CommonUtil;
import com.icontrols.kakao.common.utils.JWTUtils2;
import com.icontrols.kakao.config.AsyncConfig;
import com.icontrols.kakao.entity.DonghoInfo;
import com.icontrols.kakao.repo.DonghoInfoRepository;
import com.icontrols.kakao.service.KakaoExtensionService;
import com.icontrols.kakao.socket.wallpad.KakaoMsgHandler;
import com.icontrols.kakao.socket.wallpad.WallpadMsgSender;

@Service
public class KakaoExtensionServiceImpl implements KakaoExtensionService {
	private final Logger logger = LoggerFactory.getLogger(KakaoExtensionService.class);
	
	@Resource(name="asyncConfig")
	private AsyncConfig asyncConfig;
	
	@Resource(name="kakaoMsgHandler")
	KakaoMsgHandler kMsgHandler;
	
	@Resource(name="wallpadMsgSender")
	WallpadMsgSender wallpadMsgSender;
	
	@Autowired
	DonghoInfoRepository donghoRepository;
	@Override
	public Map<String, Object> asyncTest(Map<String, Object> param) throws Exception {

//		List<DonghoInfo> dList = donghoRepo.getDetailInfoByDongHo("108", "1103");
		logger.debug("!!!!!!!!!!!!!!!!!!!!!!!:");
		logger.debug("!!!!!!!!!!!!!!!!!!!!!!!:");
		logger.debug("!!!!!!!!!!!!!!!!!!!!!!!:");
		logger.debug("!!!!!!!!!!!!!!!!!!!!!!!:");
		
//		logger.debug(dList.get(0).toString());
		logger.debug("!!!!!!!!!!!!!!!!!!!!!!!:");
		logger.debug("!!!!!!!!!!!!!!!!!!!!!!!:");
		logger.debug("!!!!!!!!!!!!!!!!!!!!!!!:");
		
		//async 1
		logger.debug("is able = " + asyncConfig.isTaskExecute());
		Map<String, Object> param1 = new HashMap<String, Object>();
		param1.put("name", "async 1");
		param1.put("time", (long)4000);
		
		
		//async 2
		logger.debug("is able = " + asyncConfig.isTaskExecute());
		Map<String, Object> param2 = new HashMap<String, Object>();
		param2.put("name", "async 2");
		param2.put("time", (long)2000);
		
		//async 3
		logger.debug("is able = " + asyncConfig.isTaskExecute());
		Map<String, Object> param3 = new HashMap<String, Object>();
		param3.put("name", "async 3");
		param3.put("time", (long)6000);
		//async 4
		logger.debug("is able = " + asyncConfig.isTaskExecute());
		Map<String, Object> param4 = new HashMap<String, Object>();
		param4.put("name", "async 4");
		param4.put("time", (long)3000);
		
		//async 5
		logger.debug("is able = " + asyncConfig.isTaskExecute());
		Map<String, Object> param5 = new HashMap<String, Object>();
		param5.put("name", "async 5");
		param5.put("time", (long)1000);
		
		CompletableFuture<Map<String, Object>> future1 = wallpadMsgSender.getAsyncTest(param1);
		CompletableFuture<Map<String, Object>> future2 = wallpadMsgSender.getAsyncTest(param2);
		CompletableFuture<Map<String, Object>> future3 = wallpadMsgSender.getAsyncTest(param3);
		CompletableFuture<Map<String, Object>> future4 = wallpadMsgSender.getAsyncTest(param4);
		CompletableFuture<Map<String, Object>> future5 = wallpadMsgSender.getAsyncTest(param5);

		String args[] = new String[5];
		List<CompletableFuture<?>> fList = new ArrayList<>();
		
		fList.add(future1);
		fList.add(future2);
		fList.add(future3);
		fList.add(future4);
		fList.add(future5);
		
		wallpadMsgSender.getAsyncTest(param5).thenComposeAsync(wallpadMsgSender::getAsyncTest);
//		CompletableFuture.allOf(future1, future2, future3, future4, future5).join();
		CompletableFuture.allOf(fList.toArray(new CompletableFuture[fList.size()])).join();
		
		Map<String, Object> tmpMap = (Map<String, Object>)future1.get();
		logger.debug("future1 = " + tmpMap.get("result") + "END");
		
		tmpMap = (Map<String, Object>)future2.get();
		logger.debug("future2 = " + tmpMap.get("result") + "END");

		tmpMap = (Map<String, Object>)future3.get();
		logger.debug("future3 = " + tmpMap.get("result") + "END");
		
		tmpMap = (Map<String, Object>)future4.get();
		logger.debug("future4 = " + tmpMap.get("result") + "END");
		
		tmpMap = (Map<String, Object>)future5.get();
		logger.debug("future5 = " + tmpMap.get("result") + "END");
		return null;
	}
	
	@Override
	public Map<String, Object> request_grantAuthorization(Map<String, Object> param) throws Exception {
		String dong_ho = JWTUtils2.getHomeIdFromToken((String)param.get(KEY_INFO.HTTP_KEY_AUTHORIZATION));
//		int dong = Integer.parseInt(dong_ho.split("/")[0]);
//		int ho = Integer.parseInt(dong_ho.split("/")[1]);
		
		int dong = 802;
		int ho = 1103;
		
		Map<String, Object> body = (HashMap)param.get(KEY_INFO.HTTP_KEY_BODY);
		
		try {
			DonghoInfo donghoInfo = new DonghoInfo(
					Integer.toString(dong), 
					Integer.toString(ho), 
					(String) body.get(KEY_INFO.BODY_KEY_ACCESS_TOKEN),
					(String) body.get(KEY_INFO.BODY_KEY_REFRESH_TOKEN),
					Integer.toString((int)body.get(KEY_INFO.BODY_KEY_EXPIRES_IN)),
					CommonUtil.getStrTypeCurTime(),
					CommonUtil.getStrTypeCurTimeAfterSec((int)body.get(KEY_INFO.BODY_KEY_EXPIRES_IN)));
			
//			List<DonghoInfo> dList = donghoRepository.findByDongAndHo(donghoInfo.getDong(), donghoInfo.getHo());
			List<DonghoInfo> dList = donghoRepository.findByKakaoAccessTokenAndKakaoRefreshToken(
																									(String) body.get(KEY_INFO.BODY_KEY_ACCESS_TOKEN), 
																									(String) body.get(KEY_INFO.BODY_KEY_REFRESH_TOKEN)
																								);
			
			if(dList.size() > 0)
				donghoInfo.setId(dList.get(0).getId());

			donghoRepository.save(donghoInfo);
			
			logger.debug("dongho info saved complete " );
			logger.debug(donghoInfo.toString());
			
		}catch(Exception e) {
			logger.error("[Auth Database Insert Error]");
			e.printStackTrace();
			
			param.put(KEY_INFO.HTTP_KEY_ERROR, KAKAO_RESULT.getErrorInfo(KAKAO_RESULT.FAIL_INTERNAL));
		}finally {
			param.remove(KEY_INFO.HTTP_KEY_BODY);
		}
		return param;
	}
	
	@Override
	public Map<String, Object> request_discover(Map<String, Object> param) throws Exception{
		String dong_ho = JWTUtils2.getHomeIdFromToken((String)param.get(KEY_INFO.HTTP_KEY_AUTHORIZATION));
//		int dong = Integer.parseInt(dong_ho.split("/")[0]);
//		int ho = Integer.parseInt(dong_ho.split("/")[1]);
		
		int dong = 802;
		int ho = 1103;
		
		Map<String, Object> listMap = kMsgHandler.getDevicesStatusList(dong, ho);
		param.putAll(listMap);
		return param;
	}
	
	@Override
	public Map<String, Object> request_queryState(Map<String, Object> param) throws Exception {
		String dong_ho = JWTUtils2.getHomeIdFromToken((String)param.get(KEY_INFO.HTTP_KEY_AUTHORIZATION));
//		int dong = Integer.parseInt(dong_ho.split("/")[0]);
//		int ho = Integer.parseInt(dong_ho.split("/")[1]);
		
		int dong = 802;
		int ho = 1103;
		Map <String, Object> body = (HashMap)param.get(KEY_INFO.HTTP_KEY_BODY);
		
		List<String> endpointIds = (ArrayList)body.get(KEY_INFO.BODY_KEY_ENDPOINT_IDS);
		List<String> unreachableIds = new ArrayList<String>();
		
		List<CompletableFuture<Map<String, Object>>> fList = new ArrayList<>();
		
		body.clear();
		for(String endpointId:endpointIds) {
			while(true) {
    			if(asyncConfig.isTaskExecute()) {
    				fList.add(wallpadMsgSender.getDeviceStatus(dong, ho, endpointId));
    				break;
    			}
    			Thread.sleep(1000);
    		}
		}
		
		
		CompletableFuture.allOf(fList.toArray(new CompletableFuture[fList.size()])).join();
		
		logger.debug("******************************************************************************");
        logger.debug("								ASYNC D END");
        logger.debug("******************************************************************************");
		
		for(CompletableFuture<Map<String, Object>> future:fList) {
        	Map<String, Object> retMap = future.get();
        	
        	String endpointId = (String)retMap.get(KEY_INFO.BODY_KEY_ENDPOINT_ID);
        	logger.debug(endpointId + "-------->" + retMap.toString());
        	
        	if(retMap.containsKey(KEY_INFO.HTTP_KEY_ERROR)) {
				unreachableIds.add(endpointId);
				
				HashMap<String, Object> tmpMap = new HashMap<String, Object>();
				tmpMap.put("power", "off");
				
				retMap.clear();
				retMap.put(endpointId, tmpMap);
			}
        	
        	retMap.remove(KEY_INFO.BODY_KEY_ENDPOINT_ID);
        	
        	body.putAll(retMap);
        }
		
		param.put(KEY_INFO.HTTP_KEY_UNREACHABLEIDS, unreachableIds);
		param.put(KEY_INFO.HTTP_KEY_BODY, body);
		
		return param;
	}
	
	
	@Override
	public Map<String, Object> request_updateState(Map<String, Object> param) throws Exception {
		String dong_ho = JWTUtils2.getHomeIdFromToken((String)param.get(KEY_INFO.HTTP_KEY_AUTHORIZATION));
//		int dong = Integer.parseInt(dong_ho.split("/")[0]);
//		int ho = Integer.parseInt(dong_ho.split("/")[1]);
		
		int dong = 802;
		int ho = 1103;
		
		@SuppressWarnings("unchecked")
		Map <String, Object> body = (HashMap<String, Object>)param.get(KEY_INFO.HTTP_KEY_BODY);
		
		@SuppressWarnings("unchecked")
		Map<String, Object> desired = (HashMap<String, Object>)body.get(KEY_INFO.BODY_KEY_DESIRED);
		
		String endpointId = (String)body.get(KEY_INFO.BODY_KEY_ENDPOINT_ID);
		String capabilityName = (String)body.get(KEY_INFO.BODY_KEY_CAPABILITY_NAME);
		
		param.put(KEY_INFO.HTTP_KEY_BODY, kMsgHandler.sendDeviceAction(dong, ho, endpointId, capabilityName, desired));
		return param;
	}
}
